<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">

<html>
<head>
	<title>Query Maker For PostreSql</title>
<link rel="stylesheet" href="lib/color.css">
</head>
<?php
// Version 1.0
// Revised by Jay P. Narain : narain2@yahoo.com
// This code is distributed under GPL 
?>

<body bgcolor="#FFFFFF">

Query Maker For PostreSql<br>
<br>
<a href="lib/capabilites.html">Capabilites</a>
|<a href="lib/references.html">References</a>
|<a href="lib/instruct.html">Instructions</a>
<hr>
<?php
include("dbconn.inc");
if ($btnSubmit == "Create" )
{
 connectToDB("template1");
?>
<ul>
	<li>Select a database
</ul>

<?php

        $sql_select = "select * from pg_database";
        $result = pg_exec ($ConID, $sql_select);
        $numrows = pg_numrows($result);


        if (  $numrows < 1 ) {
        echo "No database exist. Make sure you have PostgreSql and PHP4 installed.";
        echo "If you do not have PostgreSql, please exit";
        echo "You need to create a database and a few populated tables"; 
        echo "Exiting"; 
	exit(1);
        }

	echo "<form method=\"post\" action=\"index.php\"><select name=\"database\">\n";
        $i = 0;
        do
        {
          $r = pg_fetch_array($result,$i);
          $tb_names[$i]  = $r["datname"];
            echo "<option value=\"$tb_names[$i]\">$tb_names[$i]</option>\n";
          $i++;
        }
        while ($i < $numrows );

	echo "</select>\n";
	echo "<input type=hidden name=host value=$host>\n";
	echo "<input type=hidden name=user value=$user>\n";	
	echo "<input type=hidden name=password value=$password>\n";	
	echo "<input type=submit name=btnSubmit value=\"SelectTables\">\n";
	echo "</form>\n";
        pg_close($ConID);
}

if ($btnSubmit == "SelectTables")
{	
 connectToDB($database);
?>

Just do the following:
<ul>
	<li>Using Ctrl key and mouse click</li>
	<li>Select all the tables required for query</li>
</ul>


<?php
      
         $sql_table = "select tablename from pg_tables where tablename NOT LIKE 'pg%' order by tablename";
        $result = pg_exec ($ConID, $sql_table);

	echo "<form method=\"post\" action=\"index.php\"><select multiple size=5 name=\"table[]\">\n";

        $i = 0;
        while ($i <  pg_numrows($result))
        {
          $r = pg_fetch_array($result,$i);
          $tb_names[$i] =   $r["tablename"];
            echo "<option value=\"$tb_names[$i]\">$tb_names[$i]</option>\n";
        $i++;
         }

	echo "</select>\n";
	echo "<input type=hidden name=host value=$host>\n";
	echo "<input type=hidden name=user value=$user>\n";	
	echo "<input type=hidden name=password value=$password>\n";	
	echo "<input type=hidden name=database value=$database>\n";
	echo "<input type=submit name=btnSubmit  value=SelectFields>\n";
	echo "</form>\n";
        pg_close($ConID);
}

if ($btnSubmit == "SelectFields")
{
 connectToDB($database);

if (isset ($table) )
  {
        $xz = matchset($table);
        $cnty = count($xz);
	$fldy  = "";
        $j = 0;
        for($j = 0; $j<$cnty; $j++)
       {
        $fldy .=  $xz[$j].":"."t".$j. ($j<$cnty-1?",":"");
       }
  }


        $xy = matchset($table);
        $cnt = count($xy);

        echo "<h3>Select Fields from tables:</h3>\n";	
        echo "<table border=1 cellpadding=3><tr>"; 
        for($j = 0; $j<$cnt; $j++)
       {
        $tabz = $xy[$j];
        echo "<th><font color =red>$tabz</font></th>\n";
       }
        echo "</tr>";
        echo "</table>\n";


	echo "<form method=\"post\" action=\"index.php\">\n"; 

        for($j = 0; $j<$cnt; $j++)
       {
        $tabz = $xy[$j];

        $SQL = "select c.relname, a.attname, a.attlen, a.atttypmod, a.attnotnull, t.typname from pg_class c, pg_attribute a, pg_type t  where c.relkind = 'r' and c.relname !~ '^pg_' and c.relname !~ '^Inv'  and a.attnum > 0 and a.attrelid = c.oid and a.atttypid = t.oid and c.relname = '$tabz' order by a.attnum ";

        $result = pg_exec($ConID,$SQL);

        $x = pg_numrows($result);

echo "<select multiple name=\"fields[]\" size = 5 >\n";
	$i = 0;
	while ($i < $x) 
	{
	    $r  = pg_fetch_array($result,$i);
            $fx = $r["attname"];
            $fields[$i] = "t".$j.".".$fx;
	    echo "<option value=\"$fields[$i]\">$fields[$i]</option>\n";

	    $i++;
	}
            $fields[$i] = "t".$j."."."*";
            echo "<option value=\"$fields[$i]\">$fields[$i]</option>\n";
	echo "</select>\n";
    }
        pg_close($ConID);

echo "<h4><b>General Options</b></h4>
<table cellspacing=0 cellpadding=1 border=1>
<tr>
<td><b>Operator</b></td>
</tr>";
echo "<tr>";
echo "<td>
<SELECT name=\"gen_op\">
<option value=\"None\">None</option>
<OPTION VALUE=\"ALL\">ALL</OPTION>
<OPTION VALUE=\"DISTINCT\">DISTINCT</OPTION>
</SELECT>
</td>
</tr>\n";
echo "</table>";

echo "<h4><b>Aggregate Functions</b></h4>
<table cellspacing=0 cellpadding=1 border=1>
<tr>
<td><b>Operator</b></td>
<td><b>Expr</b></td>
</tr>";
echo "<tr>";
for ($i=0; $i<5; $i++)
{
echo "<td>
<SELECT name=\"agg_op[$i]\">
<option value=\"None\">None</option>
<OPTION VALUE=\"DISTINCTON\">DISTINCT ON(expr)</OPTION>
<OPTION VALUE=\"AVG\">AVG(expr)</OPTION>
<OPTION VALUE=\"AVG\">AVG(expr)</OPTION>
<OPTION VALUE=\"COUNT\">COUNT(expr)</OPTION>
<OPTION VALUE=\"MAX\">MAX(expr)</OPTION>
<OPTION VALUE=\"MIN\">MIN(expr)</OPTION>
<OPTION VALUE=\"STD\">STD(expr)</OPTION>
<OPTION VALUE=\"SUM\">SUM(expr)</OPTION>
</SELECT>
</td>
<td><input type=\"text\" size=\"60\" name=\"agg_val[$i]\"></td>\n</tr>";
}
echo "</table>";
	echo "<input type=hidden name=host value=$host>\n";
	echo "<input type=hidden name=user value=$user>\n";	
	echo "<input type=hidden name=password value=$password>\n";	
	echo "<input type=hidden name=database value=$database>\n";
	echo "<input type=hidden name=fldy  value=$fldy>\n";	
	echo "<input type=hidden name=cnty  value=$cnty>\n";	
        echo "<INPUT TYPE=reset value=\"Clear All\">\n";
	echo "<input type=submit name=btnSubmit  value=SelectOptions>\n";
	echo "</form>\n";
}


if ($btnSubmit == "SelectOptions")
{
 //connectToDB($database);


        $xy = matchset($fields);
        $cnt = count($xy);

        echo "The current Select statement is:";	
	$sql = "SELECT ";

//General options      

     $gensql = "";
     if ( $gen_op != "None")
      {
        $gensql = " ".$gen_op; 
      }
        $sql .= " ".$gensql;

//Field selection

	$fldx  = "";
        $j = 0;
        for($j = 0; $j<$cnt; $j++)
       {
        $fldx = $fldx . $xy[$j] . ($j<$cnt-1?",":"");
       }

        $sql .= " ".$fldx;

//Aggregation functions

   $asql = "";
     for ($i=0; $i<5; $i++)
     {
     if ($agg_val[$i] != "")
      {
        if (strstr($agg_val[$i],"*"))
        {
           $agg_val[$i] = "*";
        }
            $asql .= $agg_op[$i]."(".$agg_val[$i].")"." "; 
       }
     }

      if ( trim($sql) == "SELECT" && $asql !== "")
        $sql .= " ".$asql." From ";
      elseif ( $sql != "" && $asql == "")
        $sql .= " From ";
      else
        $sql .= ",".$asql." From ";

        $flex = explode(":", $fldy);
	$fldz  = "";
        for($j = 0; $j<$cnty; $j++)
       {
        $fldz .=  $flex[2*$j]." ".$flex[2*$j+1]. ($j<cnty-1?",":" ");
       }
        
	$sql .= $fldz;

       echo "<p>";
       echo "<SPAN class=query>$sql</SPAN><BR><BR>\n"; 
       echo "</p>";
        
echo "<form method=\"post\" action=\"index.php\">\n";
echo "<input type=hidden name=sql value=\"$sql\">";
echo "<p>";
echo "</p>";
echo "<h3>WHERE CLAUSE</h3>
<table cellspacing=0 cellpadding=1 border=1>
<tr>
<td><b>Field</b></td>
<td><b>Operator</b></td>
<td><b>Value</b></td>
<td><b>Condition</b></td>
</tr>";
for ($i=0; $i<5; $i++)
{
echo "<td>";
echo "<SELECT name=\"qfields[$i]\">";
        $xy = matchset($fields);
        $cnt = count($xy);

        $j = 0;
        for($j = 0; $j<$cnt; $j++)
       {
	echo "<option value=\"$xy[$j]\">$xy[$j]</option>\n";
	}

	echo "</select></td>\n";
echo "<td>
<SELECT name=\"fields_op[$i]\">
<option value=\"None\">None</option>
<OPTION VALUE=\"=\">=</OPTION>
<OPTION VALUE=\"<>\"><></OPTION>
<OPTION VALUE=\">\">></OPTION>
<OPTION VALUE=\">=\">>=</OPTION>
<OPTION VALUE=\"<\"><</OPTION>
<OPTION VALUE=\"<=\"><=</OPTION>
<OPTION VALUE=\"LIKE\">LIKE</OPTION>
<OPTION VALUE=\"ALL\">ALL</OPTION>
<OPTION VALUE=\"ANY\">ANY</OPTION>
<OPTION VALUE=\"IN\">IN</OPTION>
<OPTION VALUE=\"EXISTS\">EXISTS</OPTION>
</SELECT>
</td>
<td><input type=\"text\" size=\"60\" name=\"fields_val[$i]\"></td>
<td><select  name=\"fields_enab[$i]\">
<OPTION VALUE=\" \">  </OPTION>
<OPTION VALUE=\"AND\">AND</OPTION>
<OPTION VALUE=\"OR\">OR</OPTION>
<OPTION VALUE=\"NOT\">NOT</OPTION>
</SELECT>";
echo "</td>\n</tr>";
}
echo "</table>";
echo "<p>";
echo "</p>";
echo "<h3>Subqueries or Subselect</h3>";
echo "Either Enter a subquery or Load a subquery\n";
echo "<textarea rows=10 cols=100 wrap=virtual  name=inpsubsql> $inpsubsql</textarea>\n";
echo "<select  name=\"loadsubsql\">\n";
     $dh = opendir($dirname);
           echo "<option value=\"None\">None</option>\n";
       while ( gettype ( $file = readdir( $dh )) != boolean )
        {
           echo "<option value=\"$file\">$file</option>\n";
        }
     closedir ($dh);
echo "</select>";
echo "<p>";
echo "</p>";
echo "<h3>GROUP BY CLAUSE</h3>";
echo "<table cellspacing=0 cellpadding=1 border=1>
<tr>
<td><b>Field</b></td>
</tr>";
echo "<td>";
echo "<SELECT name=\"gfields\">";
        $xy = matchset($fields);
        $cnt = count($xy);

	echo "<option value=\"None\">None</option>\n";
        $j = 0;
        for($j = 0; $j<$cnt; $j++)
       {
	echo "<option value=\"$xy[$j]\">$xy[$j]</option>\n";
	}

	echo "</select></td>\n";

echo "</table>";
echo "<p>";
echo "</p>";
echo "<h3>HAVING  CLAUSE</h3>";
echo "<table cellspacing=0 cellpadding=1 border=1>
<tr>
<td><b>Expr Field</b></td>
</tr>";
echo "<td><input type=\"text\" size=\"60\" name=\"hfields_val\">
</td>\n";
echo "</table>";
echo "<p>";
echo "</p>";
echo "<h3>Other Joins</h3>";
echo "<table cellspacing=0 cellpadding=1 border=1>
<tr>
<td><b>Operator</b></td>
</tr>";
echo "<tr>";
echo "<td>
<SELECT name=\"gen_joins\">
<option value=\"None\">None</option>
<OPTION VALUE=\"UNION\">UNION ALL</OPTION>
<OPTION VALUE=\"INTERSECT\">INTERSECT</OPTION>
<OPTION VALUE=\"EXCEPT\">EXCEPT</OPTION>
</SELECT>
</td>
</tr>\n";
echo "</table>";
echo "Either Enter or load a Join query\n";
echo "<textarea rows=10 cols=100 wrap=virtual  name=inpjoinsql> $inpjoinsql</textarea>\n";
echo "<select  name=\"loadjoinsql\">\n";
     $dh = opendir($dirname);
           echo "<option value=\"None\">None</option>\n";
       while ( gettype ( $file = readdir( $dh )) != boolean )
        {
           echo "<option value=\"$file\">$file</option>\n";
        }
     closedir ($dh);
echo "</select>";
echo "<p>";
echo "</p>";
echo "<h3>ORDER BY CLAUSE</h3>";
echo "<table cellspacing=0 cellpadding=1 border=1>
<tr>
<td><b>Field</b></td>
<td><b>Expr Field</b></td>
<td><b>SORT</b></td>
</tr>";
echo "<td>";
echo "<SELECT name=\"ofields\">";
        $xy = matchset($fields);
        $cnt = count($xy);

	echo "<option value=\"None\">None</option>\n";
        $j = 0;
        for($j = 0; $j<$cnt; $j++)
       {
	echo "<option value=\"$xy[$j]\">$xy[$j]</option>\n";
	}

	echo "</select></td>\n";
echo "<td><input type=\"text\" size=\"60\" name=\"ofields_val\"></td>\n";
echo "<td><select  name=\"ofields_enab\">
<OPTION VALUE=\"ASC\">ASC</OPTION>
<OPTION VALUE=\"DESC\">DESC</OPTION>
</select>";
echo "</td>\n";
echo "</table>";
echo "<p>";
echo "</p>";
echo "<h3>LIMIT  CLAUSE</h3>";
echo "<table cellspacing=0 cellpadding=1 border=1>
<tr>
<td><b>OFFSET BY</b></td>
<td><b>No.Of ROWS</b></td>
</tr>";
echo "<td><input type=\"text\" size=\"30\" name=\"lfields_off\">
</td>\n";
echo "<td><input type=\"text\" size=\"30\" name=\"lfields_row\">
</td>\n";
echo "</table>";
echo "<input type=hidden name=host value=$host>\n";
echo "<input type=hidden name=user value=$user>\n";	
echo "<input type=hidden name=password value=$password>\n";	
echo "<input type=hidden name=database value=$database>\n";
echo "<INPUT TYPE=reset value=\"Clear All\">\n";
echo "<input type=submit name=btnSubmit value=AssembleQuery>\n";
echo "</form>\n";
        // pg_close($ConID);
}
if ($btnSubmit == "AssembleQuery")
{
// connectToDB($database);

//Construct Query from the inputs

//Where  Constructs

     $whsql = "";
       $ssql = "";
     for ($i=0; $i<5; $i++)
     {
     if ($fields_op[$i] != "None")
            $ssql .= stripslashes($qfields[$i])." ".$fields_op[$i]." ".stripslashes($fields_val[$i])." ".$fields_enab[$i]." "; 
     }

     if ( $ssql != "")
     {
        $whsql .= "Where". " ". $ssql; 
     }

        $sql .= " ".$whsql;

//Subqueries

     $subsql = "";
     if ( $inpsubsql != "")
      {
        $subsql = "(". stripslashes($inpsubsql).")";
      }
        if ($subsql == "( )") $subsql = "";

     if ( $loadsubsql != "None")
      {
        $tmpsql = "";
        $loadfn = $dirname."/".$loadsubsql;
        $fp = fopen($loadfn, "r") or die("Could not load file");
           while (! feof($fp))
            {
              $tmpsql .= fread($fp, 64); 
            }
         fclose($fp);
        
        $subsql = "(". stripslashes($tmpsql).")";
      }

        $sql .= " ".$subsql;

//Group By  Constructs

     $gpsql = "";
     if ( $gfields != "None")
      {
        $gpsql = " Group By"." ".$gfields;
      }
        $sql .= " ".$gpsql;

//Having    Constructs

     $hvsql = "";
     if ( $hfields_val != "")
      {
        $hvsql = " Having"." ".$hfields_val;
      }
        $sql .= " ".$hvsql;

//General Join Constructs

     $jnsql = "";
     $jncond = "";
     if ( $gen_joins != "None")
      {
        $jncond = " ".$gen_joins;
      }
     if ( $inpjoinsql != "")
      {
        $jnsql = " ".stripslashes($inpsubsql);
      }
     if ( $loadjoinsql != "None")
      {
        $tmpsql = "";
        $loadfn = $dirname."/".$loadjoinsql;
        $fp = fopen($loadfn, "r") or die("Could not load file");
           while (! feof($fp))
            {
              $tmpsql .= fread($fp, 64); 
            }
         fclose($fp);
        
        $jnsql = " ". stripslashes($tmpsql);
      }

        $sql .= " ".$jncond." ".$jnsql;

//Order by  Constructs

     $obsql = "";
     if ( $ofields != "None")
      {
        $obsql = " Order by"." ".$ofields." ".$ofields_val." ".$ofields_enab;
      }
        $sql .= " ".$obsql;

//Limit Constructs

     $lmsql = "";
     if ( $lfields_off != "" &&  $lfields_row != "" )
        $lmsql .= "Limit"." ".$lfields_off.", ".$lfields_row;
     elseif($lfields_off == "" &&  $lfields_row != "" )
        $lmsql = " Limit"." ".$lfields_row;

        $sql .= " ".$lmsql;

       echo "<h3>The Select Query is</h3>";

	echo "<form method=\"post\" action=\"index.php\">\n";
	echo "<textarea rows=10 cols=100 wrap=virtual  name=cquery> $sql</textarea>\n";
	echo "<input type=hidden name=host value=$host>\n";
	echo "<input type=hidden name=user value=$user>\n";	
	echo "<input type=hidden name=password value=$password>\n";	
	echo "<input type=hidden name=database value=$database>\n";
	echo "<input type=submit name=btnSubmit value=ExecQuery>\n";
        echo "<INPUT TYPE=reset value=\"Clear All\">\n";
        echo "<hr>\n";
        echo "Save Query As";
	echo "<input type=text name=saveas value=$saveas>\n";
        echo "<hr>\n";
	echo "<input type=submit name=btnTable1 value=SaveQuery>\n";
	echo "<input type=submit name=btnTable2 value=LoadQuery>\n";
	echo "</form>\n";
//        pg_close($ConID);
}
if ($btnTable1 == "SaveQuery")
{
if ($btnSubmit == "")
  $btnSubmit  ="default";

//   $dirname = "sqldocs";
   echo "The query has been saved on file"." ".$dirname."/".$saveas;
         $savename = $dirname."/".$saveas;
         $fp = fopen($savename, "w+");
         fputs($fp, $cquery);
         fclose($fp);
   
}

if ($btnTable2 == "LoadQuery" || $btnSubmit == "Run" )
{

if ($btnSubmit == "")
  $btnSubmit  ="default";

if ($database == "")
  $database ="template1";


echo "<p>";
echo "Pick a sql file";
echo " and Input the Database for new sql file";
echo "</p>";

echo "<form method=\"post\" action=\"index.php\"><select  name=\"loadas\">\n";
//     $dirname = "sqldocs";
     $dh = opendir($dirname);
       while ( gettype ( $file = readdir( $dh )) != boolean )
        {
           echo "<option value=\"$file\">$file</option>\n";
        }
     closedir ($dh);
echo "</select>";

	echo "<input type=text   name=newdb value=$newdb>\n";
	echo "<input type=hidden name=host value=$host>\n";
	echo "<input type=hidden name=user value=$user>\n";	
	echo "<input type=hidden name=password value=$password>\n";	
	echo "<input type=hidden name=database value=$database>\n";
	echo "<input type=submit name=btnSubmit value=LoadQuery>\n";
	echo "</form>\n";
}

if ($btnSubmit == "LoadQuery" )
{
//   $dirname = "sqldocs";
        $loadfn = $dirname."/".$loadas;
        $fp = fopen($loadfn, "r") or die("Could not load file");
           while (! feof($fp))
            {
              $sql .= fread($fp, 64); 
            }
         fclose($fp);

  // Change the database if necessary
 
    if ($newdb == "")
       $newdb = $database;

        if ($database != $newdb )
         {
            $database = $newdb;
         }

       echo "<h3>The Select Query is</h3>";

	echo "<form method=\"post\" action=\"index.php\">\n";
	echo "<textarea rows=10 cols=100 wrap=virtual  name=cquery> $sql</textarea>\n";
	echo "<input type=hidden name=host value=$host>\n";
	echo "<input type=hidden name=user value=$user>\n";	
	echo "<input type=hidden name=password value=$password>\n";	
	echo "<input type=hidden name=database value=$database>\n";
	echo "<input type=submit name=btnSubmit value=ExecQuery>\n";
        echo "<INPUT TYPE=reset value=\"Clear All\">\n";
        echo "<hr>\n";
        echo "Save Query As";
	echo "<input type=text name=saveas value=$saveas>\n";
        echo "<hr>\n";
	echo "<input type=submit name=btnTable1 value=SaveQuery>\n";
	echo "<input type=submit name=btnTable2 value=LoadQuery>\n";
	echo "</form>\n";
}


if ($btnSubmit == "ExecQuery")
{

 connectToDB($database);

   $qid = pg_exec ($ConID, stripslashes($cquery));
  
  echo "<table>\n";


    echo "<table border=1 cellpadding=3>\n";
    echo "<tr class=\"trhead\">\n";
    for ($i=0; $i<pg_numfields($qid); $i++)
   {
     $hdr = pg_fieldname($qid,$i);
     if (!$hdr) {
     print ("No Information available<br>\n");
     continue;
     }
      printf( "<th>%s</th>\n",htmlspecialchars ($hdr) );
    
   }
    echo "</<tr>\n";

$classes=array("td1", "td2");
$classifier=0;
          $i = 0;
        while ($i <  pg_numrows($qid))
        {
          $row  = pg_fetch_array($qid,$i);
           echo "<tr class="."\"". $classes[$classifier]."\"".">\n";
            for ($j=0; $j< pg_numfields($qid); $j++)
             {
               printf( "<td class=normal>%s</td>\n",htmlspecialchars ($row[$j]) );
        $classifier=($classifier+1)%2;
              }
                echo "</<tr>\n";
        $i++;
        }

  echo "</table>\n";

        pg_close($ConID);
}
?>

<?php
if (empty($btnSubmit))
{
?>
Welcome to PostreSql Query Generator
<ul>
	<li>Create or run a query
</ul>

<form action="index.php" method="post">
<table border=1 cellpadding=3> 
<tr><th><font color =green>Create a Query</font></th>
<th><font color =green>Run an existing Query</font></th></tr>
<tr>
	<td><input type="submit" name="btnSubmit" value="Create"></td>
	<td><input type="submit" name="btnSubmit" value="Run"></td>
</tr>
</table>
</form>
<?php
}
?>
<?
 function matchset($xx)
{
      $arrx = array_values($xx);
      $i = 0;
      while (list ($key, $val) = each ($arrx)) {
      $xy[$i]  = $val;
      $i++;
      }
      $cnt = $i;
   return $xy;
 }

?>

</body>
</html>
