create table supplier(id serial, sno int4, sname varchar(64), city varchar(64));
insert into supplier values(1,1,'Narain','Fremont');
insert into supplier values(2,2,'Smith','London');
insert into supplier values(3,3,'Cousteau','Paris');
insert into supplier values(4,4,'Giovanni','Rome' );
create table part(id serial, pno int4, pname varchar(64), price int8);
insert into part values(1,1,'Screw',10);
insert into part values(2,2,'Nut',8); 
insert into part values(3,3,'Bolt',16); 
insert into part values(4,4,'Cobalt',64); 

create table sells (id serial, sno int8, pno int8 );
insert into sells values(1,1,1);
insert into sells values(2,1,2);
insert into sells values(3,2,4);
insert into sells values(4,3,1);
insert into sells values(5,3,3);
insert into sells values(6,4,2);
insert into sells values(7,4,3);
insert into sells values(8,4,4);

select s.sno, s.sname, count(p.pno) from supplier s, sells p
where s.sno = p.sno group by s.sno, s.sname;

select s.sno, s.sname, count(p.pno) from supplier s, sells p
where s.sno = p.sno group by s.sno, s.sname having count(p.pno) >=2;

select * from part where price > (select price from part where pname = 'Screw');

select * from supplier s where not exists ( select * from sells se where se.sno = s.sno);

select s.sno, s.sname, s.city from supplier s where s.name = 'Smith'
union
select s.sno, s.sname, s.city from supplier s where s.name = 'Narain';

select s.sno, s.sname, s.city from supplier s where s.sno > 1
intersect
select s.sno, s.sname, s.city from supplier s where s.sno > 2;


select s.sno, s.sname, s.city from supplier s where s.sno > 1
except
select s.sno, s.sname, s.city from supplier s where s.sno > 3;

